/*!-----------------------------------------------------------------------------
 * screenplay — A tiny Javascript library to timeline functions
 * v0.0.4 - built 2016-12-06
 * Licensed under the MIT License.
 * http://screenplay.jaysalvat.com/
 * ----------------------------------------------------------------------------
 * Copyright (C) 2016 Jay Salvat
 * http://jaysalvat.com/
 * --------------------------------------------------------------------------*/
!function(t,i){if("function"==typeof define&&define.amd)define(["module","exports"],i);else if("undefined"!=typeof exports)i(module,exports);else{var n={exports:{}};i(n,n.exports),t.screenplayBk=n.exports}}(this,function(t,i){"use strict";function n(t,i){if(!(t instanceof i))throw new TypeError("Cannot call a class as a function")}function e(t){var i={animation:{animation:"animationend","-o-animation":"oAnimationEnd","-moz-animation":"animationend","-webkit-animation":"webkitAnimationEnd"},transition:{transition:"transitionend","-o-transition":"oTransitionEnd","-moz-transition":"transitionend","-webkit-transition":"webkitTransitionEnd"}};try{var n=document.createElement("div");for(var e in i[t])if("undefined"!=typeof n.style[e])return i[t][e]}catch(t){return null}}Object.defineProperty(i,"__esModule",{value:!0});var s=function(){function t(t,i){for(var n=0;n<i.length;n++){var e=i[n];e.enumerable=e.enumerable||!1,e.configurable=!0,"value"in e&&(e.writable=!0),Object.defineProperty(t,e.key,e)}}return function(i,n,e){return n&&t(i.prototype,n),e&&t(i,e),i}}(),r=function(){function t(){var i=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};n(this,t);var s=i.direction,r=void 0===s?1:s,o=i.loops,a=void 0===o?1:o,h=i.loopBackward,u=void 0!==h&&h;this.steps=[],this.waits=[],this.index=0,this.loops=a,this.loopBackward=u,this.loopBuffer=a,this.dir=r,this.indexes=[],this.markers={},this.playing=!1,this.started=!1,this.running=!1,this.animationEnd=e("animation"),this.transitionEnd=e("transition"),this.timer=null,this.events={step:[],play:[],stop:[],start:[],loop:[],pause:[],before:[],after:[]},this.finale=function(){}}return s(t,[{key:"stop",value:function(){return this.started&&(this.started=!1,this.running=!1,this.playing=!1,this.finale.call(this),this._trigger("stop")),this}},{key:"play",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.loops;return this.loops=t,this.loopBuffer=t,this.started||this.dir===-1&&(this.index=this.steps.length-1),this.playing||(this.playing=!0,this.started=!0,this.running=!1,this._run(),this._trigger("play")),this}},{key:"pause",value:function(){return this.playing&&(this.playing=!1,this._trigger("pause")),this}},{key:"toggle",value:function(){return this.playing?this.pause():this.play()}},{key:"previous",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;return this.started&&(this.index=this.index-(t+1)*this.dir,this._run()),this}},{key:"next",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;return this.started&&(this.index=this.index+(t-1)*this.dir,this._run()),this}},{key:"same",value:function(){return this.index=this.index-1*this.dir,this._run(),this}},{key:"rewind",value:function(){return this.index=this.dir===-1?this.steps.length-1:0,this._run()}},{key:"step",value:function(t){for(var i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1,n=0;n<i;n++)this.steps.push(t);return this}},{key:"wait",value:function(t){return this.waits[this.steps.length-1]=t,this}},{key:"index",value:function(t){return void 0===t?this.index:(this.index=t,this)}},{key:"direction",value:function(t){return void 0===t?this.dir:(this.dir=t,this)}},{key:"reverse",value:function(){return this.direction(this.dir*-1)}},{key:"done",value:function(t){return this.finale=t,this}},{key:"loop",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:-1,i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.loopBackward;return this.loops=t,this.loopBackward=i,this.loopBuffer=t,this}},{key:"marker",value:function(t){return this.markers[t.toString()]=this.steps.length,this}},{key:"goto",value:function(t){return"string"==typeof t&&this.markers[t]&&(this.index=this.markers[t]),"number"==typeof t&&this.steps[t]&&(this.index=this.steps[t]),this._run()}},{key:"on",value:function(t,i){return this.events[t].push(i),this}},{key:"off",value:function(t,i){return i?this.events[t]=this.events[t].filter(function(t){return t!==i}):this.events[t]=[],this}},{key:"_trigger",value:function(t){var i=this;return this.events[t].forEach(function(t){return t.call(i)}),this}},{key:"_run",value:function(){var t=this;if(this.started){if(this.running=!0,this.index<0){if(this.loops!==-1){if(!(this.dir===-1||1===this.dir&&this.loopBackward))return this.stop();this.index=this.steps.length-1,this.loops=this.loops+this.dir}if(0===this.loops||this.loops>this.loopBuffer)return this.stop()}if(this.index>=this.steps.length){if(this.loops!==-1){if(!(1===this.dir||this.dir===-1&&this.loopBackward))return this.stop();this.index=0,this.loops=this.loops-this.dir}if(0===this.loops||this.loops>this.loopBuffer)return this.stop()}return setTimeout(function(){var i=t.steps[t.index],n=i;t._trigger("before"),"function"==typeof i&&(t.concurrentSteps=1,i.call(t,t._next.bind(t))),Array.isArray(n)&&(t.concurrentSteps=n.length,n.forEach(function(i){i.call(t,t._next.bind(t))})),t.index=t.index+t.dir}),this}}},{key:"_next",value:function(t){var i=this,n=0,e=function(){--i.concurrentSteps<=0&&(clearTimeout(i.timer),i.timer=setTimeout(function(){i.playing&&(i._run(),i._trigger("after"))},i.waits[i.index]))};return t?(t=Array.isArray(t)?t:[t],t.forEach(function(s){function r(){s.removeEventListener(o.animationEnd,r,!1),s.removeEventListener(o.transitionEnd,r,!1),s.removeEventListener("ended",r,!1),++n===t.length&&e()}var o=i;"undefined"!=typeof HTMLElement&&s instanceof HTMLElement&&(s.addEventListener(i.animationEnd,r,!1),s.addEventListener(i.transitionEnd,r,!1),"AUDIO"!==s.tagName&&"VIDEO"!==s.tagName||s.addEventListener("ended",r,!1)),"function"==typeof s.then&&s.then(e,e)})):e(),this}}]),t}();i.default=r,t.exports=i.default});
//# sourceMappingURL=maps/screenplay.bk.min.js.map
