/*!-----------------------------------------------------------------------------
 * screenplay — A tiny Javascript library to timeline functions
 * v0.0.4 - built 2016-12-06
 * Licensed under the MIT License.
 * http://screenplay.jaysalvat.com/
 * ----------------------------------------------------------------------------
 * Copyright (C) 2016 Jay Salvat
 * http://jaysalvat.com/
 * --------------------------------------------------------------------------*/
!function(t,i){if("function"==typeof define&&define.amd)define(["module","exports"],i);else if("undefined"!=typeof exports)i(module,exports);else{var e={exports:{}};i(e,e.exports),t.Screenplay=e.exports}}(this,function(t,i){"use strict";function e(t,i){if(!(t instanceof i))throw new TypeError("Cannot call a class as a function")}function n(t){var i={animation:{animation:"animationend","-o-animation":"oAnimationEnd","-moz-animation":"animationend","-webkit-animation":"webkitAnimationEnd"},transition:{transition:"transitionend","-o-transition":"oTransitionEnd","-moz-transition":"transitionend","-webkit-transition":"webkitTransitionEnd"}};try{var e=document.createElement("div");for(var n in i[t])if("undefined"!=typeof e.style[n])return i[t][n]}catch(t){return null}}Object.defineProperty(i,"__esModule",{value:!0});var s=function(){function t(t,i){for(var e=0;e<i.length;e++){var n=i[e];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(t,n.key,n)}}return function(i,e,n){return e&&t(i.prototype,e),n&&t(i,n),i}}(),r=function(){function t(){var i=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};e(this,t);var s=i.async,r=void 0!==s&&s,o=i.direction,h=void 0===o?1:o,a=i.loops,u=void 0===a?1:a,l=i.loopBackward,d=void 0!==l&&l;this.steps=[],this.waits=[],this.async=r,this.index=0,this.loops=u,this.loopBackward=d,this.loopBuffer=u,this.dir=h,this.inited=!1,this.playing=!1,this.timer1=null,this.timer2=null,this.markers={},this.animationEnd=n("animation"),this.transitionEnd=n("transition"),this.events={init:[],play:[],stop:[],start:[],loop:[],pause:[],before:[],after:[]},this.finale=function(){}}return s(t,[{key:"init",value:function(){return this.inited=!0,this.playing=!1,this.dir===-1?this.index=this.steps.length-1:this.index=0,this._trigger("init"),this._run(),this}},{key:"play",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.loops;return this.loops=t,this.loopBuffer=t,this.playing||(this.playing=!0,this._trigger("play"),this.inited?this.next():(this.inited=!0,this.dir===-1?this.index=this.steps.length-1:this.index=0,this._run())),this}},{key:"pause",value:function(){return this.playing&&(this.playing=!1,this._break(),this._trigger("pause")),this}},{key:"toggle",value:function(){return this.playing?this.pause():this.play()}},{key:"stop",value:function(){return this.inited&&(this.playing=!1,this.inited=!1,this._break(),this._trigger("stop"),this.finale.call(this)),this}},{key:"done",value:function(t){return this.finale=t,this}},{key:"previous",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;return this.inited&&(this.index=this.index-t*this.dir,this._run()),this}},{key:"next",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;return this.inited&&(this.index=this.index+t*this.dir,this._run()),this}},{key:"same",value:function(){return this._run(),this}},{key:"rewind",value:function(){return this.index=this.dir===-1?this.steps.length-1:0,this._run()}},{key:"loop",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:-1,i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.loopBackward;return this.loops=t,this.loopBackward=i,this.loopBuffer=t,this}},{key:"index",value:function(t){return void 0===t?this.index:(this.index=t,this)}},{key:"direction",value:function(t){return void 0===t?this.dir:(this.dir=t,this)}},{key:"reverse",value:function(){return this.direction(this.dir*-1)}},{key:"step",value:function(t){for(var i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1,e=0;e<i;e++)this.steps.push(t);return this}},{key:"wait",value:function(t){return this.waits[this.steps.length-1]=t,t&&(this.async=!0),this}},{key:"marker",value:function(t){return this.markers[t.toString()]=this.steps.length,this}},{key:"goto",value:function(t){return"string"==typeof t&&this.markers[t]&&(this.index=this.markers[t]),"number"==typeof t&&this.steps[t]&&(this.index=this.steps[t]),this._run()}},{key:"on",value:function(t,i){return this.events[t].push(i),this}},{key:"off",value:function(t,i){return i?this.events[t]=this.events[t].filter(function(t){return t!==i}):this.events[t]=[],this}},{key:"_trigger",value:function(t){var i=this;return this.events[t].forEach(function(t){return t.call(i)}),this}},{key:"_break",value:function(){this.started&&(this.started=!1,this._trigger("after")),clearTimeout(this.timer1),clearTimeout(this.timer2)}},{key:"_run",value:function(){var t=this;if(this.index<0){if(this.loops!==-1){if(!(this.dir===-1||1===this.dir&&this.loopBackward))return this.stop();this.index=this.steps.length-1,this.loops=this.loops+this.dir}else this.index=this.steps.length-1;if(0===this.loops||this.loops>this.loopBuffer)return this.stop();this._trigger("loop")}if(this.index>=this.steps.length){if(this.loops!==-1){if(!(1===this.dir||this.dir===-1&&this.loopBackward))return this.stop();this.index=0,this.loops=this.loops-this.dir}else this.index=0;if(0===this.loops||this.loops>this.loopBuffer)return this.stop();this._trigger("loop")}var i=function(){var i=t.steps[t.index],e=i;t.started=!0,t._trigger("before"),"function"==typeof i&&(t.concurrentSteps=1,i.call(t,t._next.bind(t))),Array.isArray(e)&&(t.concurrentSteps=e.length,e.forEach(function(i){i.call(t,t._next.bind(t))}))};return this.async?(clearTimeout(this.timer1),this.timer1=setTimeout(i)):i(),this}},{key:"_next",value:function(t){var i=this,e=0;if(!this.playing)return void this._trigger("after");var n=function(){i.started&&(i.started=!1,i._trigger("after")),i.index=i.index+i.dir,i._run()},s=function(){--i.concurrentSteps<=0&&(i.async?(clearTimeout(i.timer2),i.timer2=setTimeout(n,i.waits[i.index])):n())};return t?(t=Array.isArray(t)?t:[t],t.forEach(function(n){function r(){n.removeEventListener(o.animationEnd,r,!1),n.removeEventListener(o.transitionEnd,r,!1),n.removeEventListener("ended",r,!1),++e===t.length&&s()}var o=i;"undefined"!=typeof HTMLElement&&n instanceof HTMLElement&&(n.addEventListener(i.animationEnd,r,!1),n.addEventListener(i.transitionEnd,r,!1),"AUDIO"!==n.tagName&&"VIDEO"!==n.tagName||n.addEventListener("ended",r,!1)),"function"==typeof n.then&&n.then(s,s)})):s(),this}}]),t}();i.default=r,t.exports=i.default});
//# sourceMappingURL=maps/screenplay.min.js.map
